﻿' (C) Copyright 2002-2009 by Autodesk, Inc. 
'
' Permission to use, copy, modify, and distribute this software in
' object code form for any purpose and without fee is hereby granted, 
' provided that the above copyright notice appears in all copies and 
' that both that copyright notice and the limited warranty and
' restricted rights notice below appear in all supporting 
' documentation.
'
' AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
' AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
' MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
' DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
' UNINTERRUPTED OR ERROR FREE.
'
' Use, duplication, or disclosure by the U.S. Government is subject to 
' restrictions set forth in FAR 52.227-19 (Commercial Computer
' Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
' (Rights in Technical Data and Computer Software), as applicable.
'
Imports System
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.EditorInput

' This line is not mandatory, but improves loading performances
<Assembly: CommandClass(GetType(MyFirstOverrule_VB.MyCommands))> 

Namespace MyFirstOverrule_VB

    'This is our custom DrawableOverrule class.
    'In this case we're just overruling WorldDraw
    Public Class MyDrawOverrule
        Inherits Autodesk.AutoCAD.GraphicsInterface.DrawableOverrule


        Public Overrides Function WorldDraw(ByVal drawable As Autodesk.AutoCAD.GraphicsInterface.Drawable, ByVal wd As Autodesk.AutoCAD.GraphicsInterface.WorldDraw) As Boolean
            'Cast Drawable to Line so we can access its methods and properties
            Dim thisLine As Line = drawable
            'Draw some graphics primitives
            wd.Geometry.Circle(thisLine.StartPoint + 0.5 * thisLine.Delta, thisLine.Length / 2, thisLine.Normal)
            'In this case we don't want the line to draw itself, nor do we want ViewportDraw called
            Return True
            'Return MyBase.WorldDraw(drawable, wd)
        End Function

    End Class



    Public Class myCommands

        'Shared member variable to store our Overrule instance
        Private Shared mDrawOverrule As MyDrawOverrule

        ' Define Command "TOGGLEOVERRULE"
        <CommandMethod("TOGGLEOVERRULE")> _
        Public Shared Sub MyCommand()
            ' Initialize Overrule if this is the first time this function has run
            If mDrawOverrule Is Nothing Then
                mDrawOverrule = New MyDrawOverrule
                Overrule.AddOverrule(RXObject.GetClass(GetType(Line)), mDrawOverrule, False)
            End If

            'Toggle Overruling on/off
            Overrule.Overruling = Not Overrule.Overruling
            'Regen is required to update changes on screen.
            Application.DocumentManager.MdiActiveDocument.Editor.Regen()
        End Sub

    End Class

End Namespace